/**
 * @(#)Mallipallo.java
 *
 * Sample Applet application
 *
 * @author 
 * @version 1.00 05/03/15
 */
 
import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class Mallipallo extends Applet implements Runnable {
	
	private Thread vasenSaie = null;
	private Thread oikeaSaie = null;
	private Thread palloSaie = null;
	malli vasen, oikea;
	pallo Pallo;
	int palloX = 1, palloY = 1;
	
	public void init() {
		vasen = new malli(10,250);
		oikea = new malli(470,250);
		Pallo = new pallo(10,10);
		addKeyListener(new Liikuta());
	}

	class Liikuta extends KeyAdapter {
	
		public void keyPressed (KeyEvent nappis){
		switch(nappis.getKeyCode()) {
			case KeyEvent.VK_A:
				vasen.asetaX(-10);
			break;
			case KeyEvent.VK_D:
				vasen.asetaX(+10);
			break;
			case KeyEvent.VK_W:
				vasen.asetaY(-10);
			break;
			case KeyEvent.VK_S:
				vasen.asetaY(+10);
			break;
			case KeyEvent.VK_LEFT:
				oikea.asetaX(-10);
			break;
			case KeyEvent.VK_RIGHT:
				oikea.asetaX(+10);
			break;
			case KeyEvent.VK_UP:
				oikea.asetaY(-10);
			break;
			case KeyEvent.VK_DOWN:
				oikea.asetaY(+10);
			break;
			
			}
		}    
 	}
	
	public void start() {
		requestFocus();
		vasenSaie = new Thread(this);
		vasenSaie.start();
		oikeaSaie = new Thread(this);
		oikeaSaie.start();
		palloSaie = new Thread(this);
		palloSaie.start();
	}
	
	public void stop() {
	}
	
	public void run() {
		Thread tamaSaie = Thread.currentThread();
		while (vasenSaie == tamaSaie ) {
			repaint();
			try {
				tamaSaie.sleep(10);
			}
			catch ( InterruptedException e) {}
		}
		while (oikeaSaie == tamaSaie ) {
			repaint();
			try {
				tamaSaie.sleep(10);
			}
			catch ( InterruptedException e) {}
		}
		while (palloSaie == tamaSaie ) {
			repaint();
			Pallo.asetaX(palloX);
			Pallo.asetaY(palloY); 
			if ( Pallo.annaX() > 480 || Pallo.annaX() < 0 ) palloX = -palloX;
    		if ( Pallo.annaY() > 280 || Pallo.annaY() < 0 ) palloY = -palloY;
    		if (( Pallo.annaX() >= vasen.annaX() && 
    			  Pallo.annaX() <= vasen.annaX()+ 20) && 
    			 (Pallo.annaY() >= vasen.annaY() && 
    			  Pallo.annaY() <= vasen.annaY()+ 20)) {
    			palloX = -palloX;
    			palloY = -palloY;
    		}
    		if (( Pallo.annaX() >= oikea.annaX() && 
    			  Pallo.annaX() <= oikea.annaX()+ 20) && 
    			 (Pallo.annaY() >= oikea.annaY() && 
    			  Pallo.annaY() <= oikea.annaY()+ 20)) {
    			palloX = -palloX;
    			palloY = -palloY;
    		}
    		try {
				tamaSaie.sleep(10);
			}
			catch ( InterruptedException e) {}
		}
	}
	
	public void paint(Graphics g) {
		vasen.piirraMalli(g);
		oikea.piirraMalli(g);
		Pallo.piirraPallo(g);
	}
}

